#!/usr/bin/env python

import roslib
roslib.load_manifest('julius_ros')
import rospy

from hark_msgs.msg import HarkJulius
from hark_msgs.msg import HarkJuliusSrc
from hark_msgs.msg import HarkJuliusSrcVal
from roslib.msg import Header
import socket
import math
import struct
import sys
import re

MAXBUFLEN = 4096
count = 0
flag = 0
second = 0.0
host = 'localhost'
port = 10500

tmpHarkJulius = HarkJulius()
tmpcurrentid = 0

print 'rosrun julius_ros Julius3OutputPublisher.py __name:=NAMEOFNODE PORT SEVER_IP'

if len(sys.argv) >= 4:
    host = sys.argv[3]
    print 'host : %s ' % (host)

if len(sys.argv) >= 3:
    port = int(sys.argv[2])
    print 'port : %d' % (port)

sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
sock.connect((host,port))

def read_result(line):

    chstartrecog = re.search('<STARTRECOG (.*)/>',line)
    chsrcinfo = re.search('<SOURCEINFO (.*)/>',line)
    chinputparam = re.search('<INPUTPARAM (.*)/>',line)
    chrecogout = re.compile('<RECOGOUT>\s*(.*)\s*</RECOGOUT>', re.DOTALL).search(line)

    # ---------------------------------------
    # STARTRECOG

    if chstartrecog:

        attr = re.split('\s', chstartrecog.group(1))
        
        # for k in range( len(attr) ):
        #     print 'Sub Separated : %d , %s' % (k, attr[k])

        for k in range( len(attr) ):
            chid = re.search('SOURCEID="(.*)"',attr[k])
            if chid:
                tmpid = int(chid.group(1))
                # print 'id : %d' % (int(chid.group(1)))
                addflag = 1
                for num in range( len(tmpHarkJulius.src) ):
                    if tmpHarkJulius.src[num].id == tmpid:
                        addflag = 0
                if addflag == 1:
                    tmpHarkJuliusSrc = HarkJuliusSrc()
                    tmpHarkJuliusSrc.id = tmpid
                    tmpHarkJuliusSrc.status = tmpHarkJuliusSrc.STARTRECOG
                    tmpHarkJulius.src.append(tmpHarkJuliusSrc)                

        tmpcurrentid = tmpid

    # ---------------------------------------
    # INPUTPARAM

    if chinputparam:
 
        # print 'matched : %s' % (line)
        attr = re.split('\s', chinputparam.group(1))
 
        # for k in range( len(attr) ):
        #     print 'Sub Separated : %d , %s' % (k, attr[k])
 
        tmpid = tmpcurrentid
        tmpframes = 0
        tmpmsec = 0
 
   	for k in range( len(attr) ):
            chframes = re.search('FRAMES="(.*)"',attr[k])
            chmsec = re.search('MSEC="(.*)"',attr[k])
            if chframes:
                # print 'frames : %f' % (float(chframes.group(1)))
                tmpframes = float(chframes.group(1))
            if chmsec:
                # print 'msec : %d' % (int(chmsec.group(1)))
                tmpmsec = int(chmsec.group(1))
 
        for num in range( len(tmpHarkJulius.src) ):
            if tmpHarkJulius.src[num].id == tmpid:
                tmpHarkJulius.src[num].frames = tmpframes
                tmpHarkJulius.src[num].msec = tmpmsec
                tmpHarkJulius.src[num].status = tmpHarkJulius.src[num].INPUTPARAM

    # ---------------------------------------
    # SOURCEINFO
                    
    if chsrcinfo:
 
        # print 'matched : %s' % (line)
        attr = re.split('\s', chsrcinfo.group(1))
 
        # for k in range( len(attr) ):
        #     print 'Sub Separated : %d , %s' % (k, attr[k])
 
        tmpid = 0
        tmpazimuth = 0.0
        tmpelevation = 0.0
        tmpsec = 0
        tmpusec = 0
 
   	for k in range( len(attr) ):
            chid = re.search('ID="(.*)"',attr[k])
            chazimuth = re.search('AZIMUTH="(.*)"',attr[k])
            chelevation = re.search('ELEVATION="(.*)"',attr[k])
            chsec = re.search('SEC="(.*)"',attr[k])
            chusec = re.search('USEC="(.*)"',attr[k])
            if chid:
                # print 'id : %d' % (int(chid.group(1)))
                tmpid = int(chid.group(1))
            if chazimuth:
                # print 'azimuth : %f' % (float(chazimuth.group(1)))
                tmpazimuth = float(chazimuth.group(1))
            if chelevation:
                # print 'elevation : %f' % (float(chelevation.group(1)))
                tmpelevation = float(chelevation.group(1))
            if chsec and not chusec:
                # print 'sec : %d' % (int(chsec.group(1)))
                tmpsec = int(chsec.group(1))
            if chusec:
                # print 'usec : %d' % (int(chusec.group(1)))
                tmpusec = int(chusec.group(1))
 
        for num in range( len(tmpHarkJulius.src) ):
            if tmpHarkJulius.src[num].id == tmpid:
                tmpHarkJulius.src[num].azimuth = tmpazimuth
                tmpHarkJulius.src[num].elevation = tmpelevation
                tmpHarkJulius.src[num].sec = tmpsec
                tmpHarkJulius.src[num].usec = tmpusec
                tmpHarkJulius.src[num].status = tmpHarkJulius.src[num].SOURCEINFO
                
        tmpcurrentid = tmpid

    # ---------------------------------------
    # RECOGOUT
 
    if chrecogout:
        
        # print 'matched : %s' % (chrecogout.group(1))
        tmpid = tmpcurrentid

        for num in range( len(tmpHarkJulius.src) ):
            if tmpHarkJulius.src[num].id == tmpid:
                tmpHarkJulius.src[num].status = tmpHarkJulius.src[num].RECOGOUT
                chshypo = re.compile('<SHYPO\s*(.*?)>\s*(.*)\s*</SHYPO>', re.DOTALL).search(chrecogout.group(1))
                # print 'sub matched :: %s :: %s' % (chshypo.group(1), chshypo.group(2))
                chwhyponext = chshypo.group(2)
                while True:
                    chwhypo = re.compile('<WHYPO\s*(.*?)/>\s*(.*)', re.DOTALL).search(chwhyponext)
                    if not chwhypo: break
                    # print 'Found : %s' % (chwhypo.group(1))
                    attr = re.split('\s', chwhypo.group(1))
                    tmpword = ''
                    tmpclassid = 0
                    tmpcm = 0.0
                    for k in range( len(attr) ):
                        chword = re.search('WORD="(.*)"',attr[k])
                        chclassid = re.search('CLASSID="(.*)"',attr[k])
                        chcm = re.search('CM="(.*)"',attr[k])
                        if chword:
                            # print 'word : %s' % (chid.group(1))
                            tmpword = chword.group(1)
                        if chclassid:
                            # print 'classid : %d' % (int(chclassid.group(1)))
                            tmpclassid = int(chclassid.group(1))
                        if chcm:
                            # print 'cm : %f' % (float(chcm.group(1)))
                            tmpcm = float(chcm.group(1))

                    tmpphone = ''
                    chphone = re.compile('.*PHONE="(.*?)".*', re.DOTALL).search(chwhypo.group(1))
                    # print 'phone : %s' % (chphone.group(1))
                    tmpphone = chphone.group(1)

                    tmpHarkJuliusSrcVal = HarkJuliusSrcVal()
                    tmpHarkJuliusSrcVal.word = tmpword                    
                    tmpHarkJuliusSrcVal.classid = tmpclassid                   
                    tmpHarkJuliusSrcVal.phone = tmpphone                 
                    tmpHarkJuliusSrcVal.cm = tmpcm                   
                    tmpHarkJulius.src[num].src.append(tmpHarkJuliusSrcVal)                
                    chwhyponext = chwhypo.group(2)

def JuliusOutputPublisher_py():
    pub = rospy.Publisher('HarkJulius', HarkJulius)
    rospy.init_node('Julius3OutputPublisher')
    buffer = ''
    while not rospy.is_shutdown():
        message = sock.recv(MAXBUFLEN)
        buffer += message

        tmpbuffer = re.split('\n\.\n', buffer)
        buffer = tmpbuffer[ len(tmpbuffer) - 1 ]
        for k in range( len(tmpbuffer) - 1 ):
            # print 'Separated : %d , %s' % (k, tmpbuffer[k])
            read_result(tmpbuffer[k])

        # print 'Received -> %s' % (buffer)
        tmpHarkJulius.header.frame_id = "HarkRosFrameID"
        tmpHarkJulius.header.stamp = rospy.Time.now()
        pub.publish(tmpHarkJulius)
        # rospy.sleep(0.0005)

if __name__ == '__main__':
    try:
        JuliusOutputPublisher_py()
    except rospy.ROSInterruptException: pass

